#include <windows.h>
#include <vector>
#include "CPatch.h"

struct CVector
{
	float x;
	float y;
	float z;
};

struct RwRGBA
{
	char r;
	char g;
	char b;
	char a;
};

#pragma pack(push, 1)
class CParticle
{
public:
	CVector m_vecPos;
	CVector m_vecTarget;
	int m_nLifeSpanOfParticle;
	int m_ColorFadeTimer;
	float m_fGroundZ;
	CVector field_24;
	short m_nInitialAngle;
	short field_32;
	float m_fInitialZRadius;
	short field_38;
	char field_3A;
	char field_3B;
	float m_fDefaultInitialRadius;
	float m_fExpansionRate;
	short field_44;
	short field_46;
	short field_48;
	short field_4A;
	short field_4C;
	char field_4E;
	RwRGBA m_RenderColouring;
	char _pad0[1];
	CParticle *m_pPrevParticle;
};
#pragma pack(pop)


void ResizeParticle(int limit = 750)
{
	static std::vector<CParticle> gParticleArray;
	gParticleArray.resize(limit);
	
	CPatch::SetPointer(0x565960 + 0x06, &gParticleArray[0]);
	CPatch::SetPointer(0x565978 + 0x02, &gParticleArray[0].m_pPrevParticle);
	CPatch::SetPointer(0x56598A + 0x01, &gParticleArray[0]);
	CPatch::SetPointer(0x56598F + 0x02, &gParticleArray[0].m_pPrevParticle);
	CPatch::SetPointer(0x565996 + 0x02, &gParticleArray[0].m_vecPos.x);
	CPatch::SetPointer(0x5659A0 + 0x02, &gParticleArray[0].m_vecPos.y);
	CPatch::SetPointer(0x5659AA + 0x02, &gParticleArray[0].m_vecPos.z);
	CPatch::SetPointer(0x5659B4 + 0x02, &gParticleArray[0].m_vecTarget.x);
	CPatch::SetPointer(0x5659BE + 0x02, &gParticleArray[0].m_vecTarget.y);
	CPatch::SetPointer(0x5659C8 + 0x02, &gParticleArray[0].m_vecTarget.z);
	CPatch::SetPointer(0x5659D2 + 0x02, &gParticleArray[0].m_nLifeSpanOfParticle);
	CPatch::SetPointer(0x5659DC + 0x02, &gParticleArray[0].m_ColorFadeTimer);
	CPatch::SetPointer(0x5659E6 + 0x02, &gParticleArray[0].m_fDefaultInitialRadius);
	CPatch::SetPointer(0x5659F0 + 0x02, &gParticleArray[0].m_fExpansionRate);
	CPatch::SetPointer(0x5659FA + 0x02, &gParticleArray[0].field_3A);
	CPatch::SetPointer(0x565A01 + 0x03, &gParticleArray[0].field_44);
	CPatch::SetPointer(0x565A0A + 0x02, &gParticleArray[0].field_3B);
	CPatch::SetPointer(0x565A11 + 0x03, &gParticleArray[0].field_46);
	CPatch::SetPointer(0x565A1A + 0x03, &gParticleArray[0].m_nInitialAngle);
	CPatch::SetPointer(0x565A23 + 0x03, &gParticleArray[0].field_32);
	CPatch::SetPointer(0x565A2C + 0x02, &gParticleArray[0].m_fInitialZRadius);
	CPatch::SetPointer(0x565A36 + 0x03, &gParticleArray[0].field_38);
	CPatch::SetPointer(0x565A3F + 0x02, &gParticleArray[0].field_4E);
	CPatch::SetPointer(0x565A46 + 0x03, &gParticleArray[0].field_48);
	CPatch::SetPointer(0x565A4F + 0x03, &gParticleArray[0].field_4C);
	CPatch::SetPointer(0x565A58 + 0x03, &gParticleArray[0].field_4A);
	//CPatch::SetPointer(0x565AB1 + 0x01, &gParticleArray[0]);
	//CPatch::SetPointer(0x565AEC + 0x01, &gParticleArray[0]);

	CPatch::SetInt(0x565970 + 0x02, gParticleArray.size() - 1);
	CPatch::SetInt(0x565A64 + 0x02, gParticleArray.size());
	//CPatch::SetInt(0x565AA0 + 0x01, gParticleArray.size());
	//CPatch::SetInt(0x565AE0 + 0x01, gParticleArray.size());

}

BOOL APIENTRY DllMain(HMODULE hModule, DWORD reason, LPVOID lpReserved)
{
	if(reason == DLL_PROCESS_ATTACH)
	{
		ResizeParticle(100000);
	}
	return TRUE;
}